diff --git a/include/sway/input/seat.h b/include/sway/input/seat.h
index 2e98a24420..56c0407919 100644
--- a/include/sway/input/seat.h
+++ b/include/sway/input/seat.h
@@ -21,6 +21,8 @@ struct sway_seatop_impl {
 	void (*pointer_axis)(struct sway_seat *seat,
 			struct wlr_event_pointer_axis *event);
 	void (*rebase)(struct sway_seat *seat, uint32_t time_msec);
+	void (*tablet_tool_tip)(struct sway_seat *seat, struct sway_tablet_tool *tool,
+			uint32_t time_msec, enum wlr_tablet_tool_tip_state state);
 	void (*tablet_tool_motion)(struct sway_seat *seat, struct sway_tablet *tablet,
 			struct sway_tablet_tool *tool, uint32_t time_msec, double dx, double dy);
 	void (*end)(struct sway_seat *seat);
@@ -268,6 +270,10 @@ void seatop_pointer_motion(struct sway_seat *seat, uint32_t time_msec,
 void seatop_pointer_axis(struct sway_seat *seat,
 		struct wlr_event_pointer_axis *event);
 
+void seatop_tablet_tool_tip(struct sway_seat *seat,
+		struct sway_tablet_tool *tool, uint32_t time_msec,
+		enum wlr_tablet_tool_tip_state state);
+
 void seatop_tablet_tool_motion(struct sway_seat *seat,
 		struct sway_tablet *tablet, struct sway_tablet_tool *tool,
 		uint32_t time_msec, double dx, double dy);
diff --git a/sway/input/cursor.c b/sway/input/cursor.c
index 90ed3b5c7d..98b5e5c122 100644
--- a/sway/input/cursor.c
+++ b/sway/input/cursor.c
@@ -544,7 +544,8 @@ static void handle_tablet_tool_position(struct sway_cursor *cursor,
 	node_at_coords(seat, cursor->cursor->x, cursor->cursor->y, &surface, &sx, &sy);
 	struct sway_tablet_tool *sway_tool = tool->data;
 
-	if (surface && wlr_surface_accepts_tablet_v2(tablet->tablet_v2, surface)) {
+	if ((surface && wlr_surface_accepts_tablet_v2(tablet->tablet_v2, surface)) ||
+			wlr_tablet_tool_v2_has_implicit_grab(sway_tool->tablet_v2_tool)) {
 		seatop_tablet_tool_motion(seat, tablet, sway_tool, time_msec, dx, dy);
 	} else {
 		wlr_tablet_v2_tablet_tool_notify_proximity_out(sway_tool->tablet_v2_tool);
@@ -652,6 +653,8 @@ static void handle_tool_tip(struct wl_listener *listener, void *data) {
 
 		wlr_tablet_v2_tablet_tool_notify_up(sway_tool->tablet_v2_tool);
 	}
+
+	seatop_tablet_tool_tip(seat, sway_tool, event->time_msec, event->state);
 }
 
 static struct sway_tablet *get_tablet_for_device(struct sway_cursor *cursor,
diff --git a/sway/input/seat.c b/sway/input/seat.c
index 4abffb2519..935ae21ce6 100644
--- a/sway/input/seat.c
+++ b/sway/input/seat.c
@@ -1463,6 +1463,14 @@ void seatop_pointer_axis(struct sway_seat *seat,
 	}
 }
 
+void seatop_tablet_tool_tip(struct sway_seat *seat,
+		struct sway_tablet_tool *tool, uint32_t time_msec,
+		enum wlr_tablet_tool_tip_state state) {
+	if (seat->seatop_impl->tablet_tool_tip) {
+		seat->seatop_impl->tablet_tool_tip(seat, tool, time_msec, state);
+	}
+}
+
 void seatop_tablet_tool_motion(struct sway_seat *seat,
 		struct sway_tablet *tablet, struct sway_tablet_tool *tool,
 		uint32_t time_msec, double dx, double dy) {
diff --git a/sway/input/seatop_default.c b/sway/input/seatop_default.c
index e0838c0445..e50aa28b90 100644
--- a/sway/input/seatop_default.c
+++ b/sway/input/seatop_default.c
@@ -198,6 +198,25 @@ static void state_add_button(struct seatop_default_event *e, uint32_t button) {
  * Functions used by handle_button  /
  *--------------------------------*/
 
+static void handle_tablet_tool_tip(struct sway_seat *seat,
+		struct sway_tablet_tool *tool, uint32_t time_msec,
+		enum wlr_tablet_tool_tip_state state) {
+	if (state != WLR_TABLET_TOOL_TIP_DOWN) {
+		return;
+	}
+
+	struct sway_cursor *cursor = seat->cursor;
+
+	struct wlr_surface *surface = NULL;
+	double sx, sy;
+	struct sway_node *node = node_at_coords(seat,
+		cursor->cursor->x, cursor->cursor->y, &surface, &sx, &sy);
+	struct sway_container *cont = node && node->type == N_CONTAINER ?
+		node->sway_container : NULL;
+
+	seatop_begin_down(seat, cont, time_msec, sx, sy);
+}
+
 static void handle_button(struct sway_seat *seat, uint32_t time_msec,
 		struct wlr_input_device *device, uint32_t button,
 		enum wlr_button_state state) {
@@ -650,6 +669,7 @@ static const struct sway_seatop_impl seatop_impl = {
 	.button = handle_button,
 	.pointer_motion = handle_pointer_motion,
 	.pointer_axis = handle_pointer_axis,
+	.tablet_tool_tip = handle_tablet_tool_tip,
 	.tablet_tool_motion = handle_tablet_tool_motion,
 	.rebase = handle_rebase,
 	.allow_set_cursor = true,
diff --git a/sway/input/seatop_down.c b/sway/input/seatop_down.c
index 358d5c59b9..c37ded2b85 100644
--- a/sway/input/seatop_down.c
+++ b/sway/input/seatop_down.c
@@ -1,6 +1,7 @@
 #define _POSIX_C_SOURCE 200809L
 #include <float.h>
 #include <wlr/types/wlr_cursor.h>
+#include <wlr/types/wlr_tablet_v2.h>
 #include "sway/input/cursor.h"
 #include "sway/input/seat.h"
 #include "sway/tree/view.h"
@@ -49,6 +50,28 @@ static void handle_pointer_motion(struct sway_seat *seat, uint32_t time_msec,
 	}
 }
 
+static void handle_tablet_tool_tip(struct sway_seat *seat,
+		struct sway_tablet_tool *tool, uint32_t time_msec,
+		enum wlr_tablet_tool_tip_state state) {
+	if (state == WLR_TABLET_TOOL_TIP_UP) {
+		seatop_begin_default(seat);
+	}
+}
+
+static void handle_tablet_tool_motion(struct sway_seat *seat,
+		struct sway_tablet *tablet, struct sway_tablet_tool *tool,
+		uint32_t time_msec, double dx, double dy) {
+	struct seatop_down_event *e = seat->seatop_data;
+	struct sway_container *con = e->con;
+	if (seat_is_input_allowed(seat, con->view->surface)) {
+		double moved_x = seat->cursor->cursor->x - e->ref_lx;
+		double moved_y = seat->cursor->cursor->y - e->ref_ly;
+		double sx = e->ref_con_lx + moved_x;
+		double sy = e->ref_con_ly + moved_y;
+		wlr_tablet_v2_tablet_tool_notify_motion(tool->tablet_v2_tool, sx, sy);
+	}
+}
+
 static void handle_unref(struct sway_seat *seat, struct sway_container *con) {
 	struct seatop_down_event *e = seat->seatop_data;
 	if (e->con == con) {
@@ -60,6 +83,8 @@ static const struct sway_seatop_impl seatop_impl = {
 	.button = handle_button,
 	.pointer_motion = handle_pointer_motion,
 	.pointer_axis = handle_pointer_axis,
+	.tablet_tool_tip = handle_tablet_tool_tip,
+	.tablet_tool_motion = handle_tablet_tool_motion,
 	.unref = handle_unref,
 	.allow_set_cursor = true,
 };
